#ifndef _IO_PORT_H_
#define _IO_PORT_H_


#include <stdint.h>


typedef struct io_port_t {
	volatile uint8_t *ddr;
	volatile uint8_t *port;
	uint8_t bit;
} io_port;


#define IO_PORT_ARDUINO_ANALOG_BASE 14
#define IO_PORT(ddr, port, bit) ((io_port) {&ddr, &port, bit})
#define IO_PORT_ARDUINO(x) (((x)>=0&&(x)<=7)?(IO_PORT(DDRD, PORTD, (x))): \
	(((x)>=8&&(x)<=13)?(IO_PORT(DDRB, PORTB, ((x)-8))): \
	(((x)>=14&&(x)<=19)?(IO_PORT(DDRC, PORTC, ((x)-IO_PORT_ARDUINO_ANALOG_BASE))): \
	((io_port) {0, 0, 0}))))
#define IO_PORT_OUT 1
#define IO_PORT_IN  0
#define IO_PORT_INIT(p,io) {if(io) (*(p).ddr |= (1<<((p).bit)));else (*(p).ddr &= ~(1<<((p).bit)));}
#define IO_PORT_SET(p)     {*(p).port |= (1<<((p).bit));}
#define IO_PORT_CLR(p)     {*(p).port &= ~(1<<((p).bit));}
#define IO_PORT_SETX(p,x)  {if(x){IO_PORT_SET(p);}else{IO_PORT_CLR(p);}}



#endif
