#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdint.h>
#include <stdio.h>
#include "io_port.h"
#include "st7920.h"
//#include "adc.h"


void delay_ms(uint32_t);
void delay_us(uint32_t);

st7920_t lcd;
uint8_t buf[16];

const uint32_t max_rpm = 3600;
//const uint8_t rpm_size = 2;
volatile uint16_t cnt = 0;
//volatile uint16_t rpm_cnt = 0;
//volatile uint32_t rpm_[2]; // rpm_size
volatile uint32_t rpm = 0;
volatile uint32_t rotations = 0;
//volatile uint32_t rotations[2]; // rpm_size
//volatile uint32_t t_diff_ms = 0;
//volatile uint32_t t_last_rotation = 0;
//volatile uint32_t ms = 0;


int main (void) {
	//DDRC &= ~(1<<5);
	//ADC_init();

	DDRD &= ~(1<<2);
	DDRD |= (1<<3);
	//PORTD |= (1<<2); // enable pull-up
	EICRA |= ((1<<ISC01) | (1<<ISC00)); // rising edge
	EIMSK |= (1<<INT0);

	TCCR0A |= (1<<WGM01); // CTC
	OCR0A = 250-1; // 2
	TIMSK0 = (1<<OCIE0A); // enable compare match interrupt
	sei();
	TCCR0B |= ((1<<CS01) | (1<<CS00)); // prescaler: 64 => 1ms    //(1<<CS01); // prescaler: 8 => 16000000/8 = 2000000 => 2000000/2 = 1000000 => 1/1000000 => 0.000001 => 0.001ms => 1us



	st7920_init_4bit(&lcd, IO_PORT_ARDUINO(8), IO_PORT_ARDUINO(9), IO_PORT_ARDUINO(4), IO_PORT_ARDUINO(5), IO_PORT_ARDUINO(6), IO_PORT_ARDUINO(7));


	sprintf((char*) buf, "DZB Test!");
	st7920_str(&lcd, buf);
	delay_ms(3000);



	while (1) {
		delay_ms(1000);
		st7920_clear(&lcd);


		sprintf((char*) buf, "rpm: %lu", rpm);
		st7920_str(&lcd, buf);

		//st7920_setcursor(&lcd, 0, 0);
		//sprintf((char*) buf, ">%d<", ADC_read(5));
		//st7920_str(&lcd, buf);

		st7920_setcursor(&lcd, 0, 1);
		sprintf((char*) buf, "max_rpm: %lu", max_rpm);
		st7920_str(&lcd, buf);
	}


	while(1);
	return 0;
}


ISR (INT0_vect) {
	/*
	uint8_t i;
	for (i=0; i<rpm_size; i++)
		rotations[i]++;
	// */

	rotations++;
}


//
ISR (TIMER0_COMPA_vect) {
	cli();
	if (++cnt == 1000) {
		rpm = rotations*60;
		rotations = 0;

		if (rpm >= max_rpm)
			PORTD |= (1<<3);
		else
			PORTD &= ~(1<<3);



		/*
		rpm_[rpm_cnt] = rotations[(rpm_cnt+1)%rpm_size]*30; // 2sec => *30 // rpm_size*t
		rpm = rpm_[rpm_cnt];
		rotations[(rpm_cnt+1)%rpm_size] = 0;

		rpm_cnt++;
		// */
		cnt = 0;
	}
	sei();


	//ms++;
}
// */


void delay_ms (uint32_t t) {
	//uint32_t t_sleep = ms+t;
	//while(t_sleep > ms);

	//delay_us(t*1000);

	for (; t>0; t--)
		_delay_ms(1);
}

void delay_us (uint32_t t) {
	for (; t>0; t--)
		_delay_us(1);
}
