#include <util/delay.h>
#include "st7920.h"


void st7920_init_4bit (st7920_t *st7920, io_port rs, /*io_port rw,*/ io_port e, io_port d0, io_port d1, io_port d2, io_port d3) {
	st7920->rs = rs;
	//st7920->rw = rw;
	st7920->e = e;

	st7920->d0 = d0;
	st7920->d1 = d1;
	st7920->d2 = d2;
	st7920->d3 = d3;


	IO_PORT_INIT(st7920->rs, IO_PORT_OUT);
	//IO_PORT_INIT(st7920->rw, IO_PORT_OUT);
	IO_PORT_INIT(st7920->e, IO_PORT_OUT);

	_delay_ms(100);
	IO_PORT_CLR(st7920->rs);
	IO_PORT_CLR(st7920->e);
	//IO_PORT_SETX(st7920->rw, ST7920_WRITE);

	_delay_ms(100);
	/*
	st7920_write(st7920, 0x03);
	_delay_us(4500);
	st7920_write(st7920, 0x03);
	_delay_us(4500);
	st7920_write(st7920, 0x03);
	_delay_us(150);
	st7920_write(st7920, 0x02);
	//*/

	_delay_ms(5);

	st7920_cmd(st7920, ST7920_FUNCTION_SET | (ST7920_4BIT | ST7920_BASIC_INSTRUCTIONS));
	_delay_ms(5);
	st7920_cmd(st7920, ST7920_FUNCTION_SET | (ST7920_4BIT | ST7920_BASIC_INSTRUCTIONS));
	_delay_ms(5);

	st7920_cmd(st7920, ST7920_DISPLAY_CONTROL | (ST7920_DISPLAY_ON | ST7920_CURSOR_OFF | ST7920_BLINK_OFF));
	_delay_ms(5);
	st7920_clear(st7920);
	_delay_ms(5);
	st7920_cmd(st7920, ST7920_ENTRY_MODE_SET | 0x02);
	//st7920_cmd(st7920, ST7920_ENTRY_MODE_SET | (ST7920_ENTRY_LEFT | ST7920_ENTRY_SHIFT_DECREMENT));
	_delay_ms(5);


	_delay_ms(100);
}


void st7920_clear (st7920_t *st9720) {
	st7920_cmd(st9720, ST7920_DISPLAY_CLEAR);
	_delay_ms(2);
}


void st7920_cmd (st7920_t *st9720, uint8_t cmd) {
	st7920_send(st9720, cmd, ST7920_CMD, ST7920_WRITE);
}

void st7920_send (st7920_t *st7920, uint8_t data, uint8_t rs, uint8_t rw) {
	IO_PORT_SETX(st7920->rs, rs);
	//IO_PORT_SETX(st7920->rw, rw);
	//IO_PORT_SETX(st7920->rw, ST7920_WRITE);

	st7920_write(st7920, data >> 4);
	st7920_write(st7920, data & 0x0F);
}

void st7920_write (st7920_t *st7920, uint8_t data) {
	IO_PORT_INIT(st7920->d0, IO_PORT_OUT);
	IO_PORT_INIT(st7920->d1, IO_PORT_OUT);
	IO_PORT_INIT(st7920->d2, IO_PORT_OUT);
	IO_PORT_INIT(st7920->d3, IO_PORT_OUT);

	IO_PORT_SETX(st7920->d0, (data >> 0) & 0x01);
	IO_PORT_SETX(st7920->d1, (data >> 1) & 0x01);
	IO_PORT_SETX(st7920->d2, (data >> 2) & 0x01);
	IO_PORT_SETX(st7920->d3, (data >> 3) & 0x01);


	_delay_us(1);
	IO_PORT_SET(st7920->e);
	_delay_us(1);
	IO_PORT_CLR(st7920->e);
	_delay_us(100);
}

void st7920_str (st7920_t *st7920, uint8_t *s) {
	while (*s != 0)
		st7920_send(st7920, *s++, ST7920_DATA, ST7920_WRITE);
}

void st7920_setcursor (st7920_t *st7920, uint8_t col, uint8_t row) {
	//int row_offsets[] = {0x00, 0x40};
	//st7920_cmd(st7920, ST7920_SETDDRAMADDR | (col + row_offsets[row]));
	st7920_cmd(st7920, ST7920_SET_DDRAM_ADDRESS | (col + (row * 0x40))); // only works with 2 lines
}
