#ifndef _ST7920_H_
#define _ST7920_H_


#include "io_port.h"


typedef struct _st7920_t {
	io_port rs, rw, e, d0, d1, d2, d3;
} st7920_t;


#define ST7920_WRITE					0x00
#define ST7920_READ						0x01

#define ST7920_CMD						0x00
#define ST7920_DATA						0x01

#define ST7920_DISPLAY_CLEAR			0x01
#define ST7920_RETURN_HOME				0x02
#define ST7920_ENTRY_MODE_SET			0x04
#define ST7920_DISPLAY_CONTROL			0x08
#define ST7920_CURSOR_DISPLAY_CONTROL	0x10
#define ST7920_FUNCTION_SET				0x20
#define ST7920_SET_CGRAM_ADDRESS		0x40
#define ST7920_SET_DDRAM_ADDRESS		0x80

#define ST7920_DISPLAY_OFF				0x00
#define ST7920_CURSOR_OFF				0x00
#define ST7920_BLINK_OFF				0x00
#define ST7920_DISPLAY_ON				0x04
#define ST7920_CURSOR_ON				0x02
#define ST7920_BLINK_ON					0x01

#define ST7920_8BIT						0x10
#define ST7920_4BIT						0x00

#define ST7920_BASIC_INSTRUCTIONS		0x00
#define ST7920_EXTENDED_INSTRUCTIONS	0x04




void st7920_init_4bit(st7920_t*, io_port, /*io_port,*/ io_port, io_port, io_port, io_port, io_port);
void st7920_send(st7920_t*, uint8_t, uint8_t, uint8_t);
void st7920_write(st7920_t*, uint8_t);
void st7920_str(st7920_t*, uint8_t*);
void st7920_cmd(st7920_t*, uint8_t);
void st7920_clear(st7920_t*);
void st7920_setcursor(st7920_t*, uint8_t, uint8_t);


#endif
